// **********************************************************************
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_DECLARATIONS_H
#define OB_DECLARATIONS_H

// TODO: This file must be cleaned up! Also: Are really all
// declarations in here necessary?

namespace OB
{

class InputStream;
class OutputStream;
class CountStream;

class ConstructedInfo;
class TypeCodeConst;

class StubImplBase;
typedef StubImplBase* StubImplBase_ptr;

//
// The Dispatch Status
// TODO: I currently simply don't know any better place to put this
//
enum DispatchStatus
{
    DispatchStatusOK,
    DispatchStatusExcept,
    DispatchStatusNoObject,
    DispatchStatusNoOperation
};

} // End of namespace OB

void OBDuplicate(OB::StubImplBase_ptr);
void OBRelease(OB::StubImplBase_ptr);

namespace OB
{

typedef ObjVar< StubImplBase > StubImplBase_var;

} // End of namespace OB

namespace CORBA
{

//XXX
typedef char* RepositoryId;
typedef String_var RepositoryId_var;
//XXX

class Any;
typedef OB::VarVar< Any > Any_var;

struct ServiceInformation;
typedef OB::VarVar< ServiceInformation > ServiceInformation_var;
typedef ServiceInformation& ServiceInformation_out;
typedef UShort ServiceType;

class ValueBase;

class ValueFactoryBase;
typedef ValueFactoryBase* ValueFactory;

class Object;
typedef Object* Object_ptr;

class AbstractBase;
typedef AbstractBase* AbstractBase_ptr;

class Policy;
typedef Policy* Policy_ptr;

typedef ULong PolicyType;
typedef ULong_out PolicyType_out;

typedef OB::ULongSeq PolicyTypeSeq;
typedef OB::SeqVar< PolicyTypeSeq > PolicyTypeSeq_var;
typedef OB::SeqOut< PolicyTypeSeq > PolicyTypeSeq_out;

class TypeCode;
typedef TypeCode* TypeCode_ptr;

class Principal;
typedef Principal* Principal_ptr;

class Environment;
typedef Environment* Environment_ptr;

class Context;
typedef Context* Context_ptr;

class NamedValue;
typedef NamedValue* NamedValue_ptr;

class NVList;
typedef NVList* NVList_ptr;

class ExceptionList;
typedef ExceptionList* ExceptionList_ptr;

class ContextList;
typedef ContextList* ContextList_ptr;

class Request;
typedef Request* Request_ptr;

class InterfaceDef;
typedef InterfaceDef* InterfaceDef_ptr;

class OperationDef;
typedef OperationDef* OperationDef_ptr;

class ORB;
typedef ORB* ORB_ptr;

#if 0 // XXX is this necessary?
class BOA;
typedef BOA* BOA_ptr;
typedef OB::ObjVar< BOA > BOA_var;
#endif

class DynAny;
typedef DynAny* DynAny_ptr;

class DynFixed;
typedef DynFixed* DynFixed_ptr;

class DynEnum;
typedef DynEnum* DynEnum_ptr;

class DynStruct;
typedef DynStruct* DynStruct_ptr;

class DynUnion;
typedef DynUnion* DynUnion_ptr;

class DynSequence;
typedef DynSequence* DynSequence_ptr;

class DynArray;
typedef DynArray* DynArray_ptr;

} // End of namespace CORBA

void OBDuplicate(CORBA::ValueBase*);
void OBRelease(CORBA::ValueBase*);
void OBDuplicate(CORBA::ValueFactoryBase*);
void OBRelease(CORBA::ValueFactoryBase*);
void OBDuplicate(CORBA::Object_ptr);
void OBRelease(CORBA::Object_ptr);
void OBDuplicate(CORBA::AbstractBase_ptr);
void OBRelease(CORBA::AbstractBase_ptr);
void OBDuplicate(CORBA::Policy_ptr);
void OBRelease(CORBA::Policy_ptr);
void OBDuplicate(CORBA::TypeCode_ptr);
void OBRelease(CORBA::TypeCode_ptr);
void OBDuplicate(CORBA::Principal_ptr);
void OBRelease(CORBA::Principal_ptr);
void OBDuplicate(CORBA::Environment_ptr);
void OBRelease(CORBA::Environment_ptr);
void OBDuplicate(CORBA::Context_ptr);
void OBRelease(CORBA::Context_ptr);
void OBDuplicate(CORBA::NamedValue_ptr);
void OBRelease(CORBA::NamedValue_ptr);
void OBDuplicate(CORBA::NVList_ptr);
void OBRelease(CORBA::NVList_ptr);
void OBDuplicate(CORBA::ExceptionList_ptr);
void OBRelease(CORBA::ExceptionList_ptr);
void OBDuplicate(CORBA::ContextList_ptr);
void OBRelease(CORBA::ContextList_ptr);
void OBDuplicate(CORBA::Request_ptr);
void OBRelease(CORBA::Request_ptr);
void OBDuplicate(CORBA::InterfaceDef_ptr);
void OBRelease(CORBA::InterfaceDef_ptr);
void OBDuplicate(CORBA::OperationDef_ptr);
void OBRelease(CORBA::OperationDef_ptr);
void OBDuplicate(CORBA::ORB_ptr);
void OBRelease(CORBA::ORB_ptr);
void OBDuplicate(CORBA::DynAny_ptr);
void OBRelease(CORBA::DynAny_ptr);
void OBDuplicate(CORBA::DynFixed_ptr);
void OBRelease(CORBA::DynFixed_ptr);
void OBDuplicate(CORBA::DynEnum_ptr);
void OBRelease(CORBA::DynEnum_ptr);
void OBDuplicate(CORBA::DynStruct_ptr);
void OBRelease(CORBA::DynStruct_ptr);
void OBDuplicate(CORBA::DynUnion_ptr);
void OBRelease(CORBA::DynUnion_ptr);
void OBDuplicate(CORBA::DynSequence_ptr);
void OBRelease(CORBA::DynSequence_ptr);
void OBDuplicate(CORBA::DynArray_ptr);
void OBRelease(CORBA::DynArray_ptr);

namespace CORBA
{

typedef OB::ObjVar< ValueBase > ValueBase_var;

typedef OB::ObjVar< ValueFactoryBase > ValueFactoryBase_var;

typedef OB::ObjVar< Object > Object_var;
typedef OB::ObjOut< Object > Object_out;

typedef OB::ObjVar< AbstractBase > AbstractBase_var;
typedef OB::ObjOut< AbstractBase > AbstractBase_out;

typedef OB::ObjVar< Policy > Policy_var;
class OBUnique_PolicyList;
typedef OB::ObjSeq< Policy, OBUnique_PolicyList > PolicyList;

typedef OB::SeqVar< PolicyList > PolicyList_var;
typedef OB::SeqOut< PolicyList > PolicyList_out;

typedef OB::ObjVar< TypeCode > TypeCode_var;

typedef OB::ObjVar< Principal > Principal_var;

typedef OB::ObjVar< Environment > Environment_var;
typedef OB::ObjOut< Environment > Environment_out;

typedef OB::ObjVar< Context > Context_var;
typedef OB::ObjOut< Context > Context_out;

typedef OB::ObjVar< NamedValue > NamedValue_var;
typedef OB::ObjOut< NamedValue > NamedValue_out;

typedef OB::ObjVar< NVList > NVList_var;
typedef OB::ObjOut< NVList > NVList_out;

typedef OB::ObjVar< ExceptionList > ExceptionList_var;
typedef OB::ObjOut< ExceptionList > ExceptionList_out;

typedef OB::ObjVar< ContextList > ContextList_var;
typedef OB::ObjOut< ContextList > ContextList_out;

typedef OB::ObjVar< Request > Request_var;
typedef OB::ObjOut< Request > Request_out;

typedef OB::ObjVar< InterfaceDef > InterfaceDef_var;

typedef OB::ObjVar< OperationDef > OperationDef_var;

typedef OB::ObjVar< ORB > ORB_var;

typedef OB::ObjVar< DynAny > DynAny_var;

typedef OB::ObjVar< DynFixed > DynFixed_var;

typedef OB::ObjVar< DynEnum > DynEnum_var;

typedef OB::ObjVar< DynStruct > DynStruct_var;

typedef OB::ObjVar< DynUnion > DynUnion_var;

typedef OB::ObjVar< DynSequence > DynSequence_var;

typedef OB::ObjVar< DynArray > DynArray_var;

} // End of namespace CORBA

namespace PortableServer
{

class POA;
typedef POA* POA_ptr;
typedef POA* POARef;

// TODO
typedef OB::OctetSeq ObjectId;
typedef OB::OctetSeq_var ObjectId_var;

class ServantActivator;
typedef ServantActivator* ServantActivator_ptr;
typedef ServantActivator* ServantActivatorRef;

} // End of namespace PortableServer

void OBDuplicate(PortableServer::POA_ptr);
void OBRelease(PortableServer::POA_ptr);
void OBDuplicate(PortableServer::ServantActivator_ptr);
void OBRelease(PortableServer::ServantActivator_ptr);

namespace PortableServer
{

typedef OB::ObjVar< POA > POA_var;

typedef OB::ObjVar< ServantActivator > ServantActivator_var;
typedef OB::ObjOut< ServantActivator > ServantActivator_out;

} // End of namespace PortableServer

namespace OCI
{

class Buffer;
typedef Buffer* Buffer_ptr;

class TransportInfo;
typedef TransportInfo* TransportInfo_ptr;

class Transport;
typedef Transport* Transport_ptr;

class ConnectorInfo;
typedef ConnectorInfo* ConnectorInfo_ptr;

class Connector;
typedef Connector* Connector_ptr;

class AcceptorInfo;
typedef AcceptorInfo* AcceptorInfo_ptr;

class Acceptor;
typedef Acceptor* Acceptor_ptr;

class ConFactory;
typedef ConFactory* ConFactory_ptr;

class ConFactoryRegistry;
typedef ConFactoryRegistry* ConFactoryRegistry_ptr;

class AccRegistry;
typedef AccRegistry* AccRegistry_ptr;

} // End namespace OCI

void OBDuplicate(OCI::Buffer_ptr);
void OBRelease(OCI::Buffer_ptr);
void OBDuplicate(OCI::TransportInfo_ptr);
void OBRelease(OCI::TransportInfo_ptr);
void OBDuplicate(OCI::Transport_ptr);
void OBRelease(OCI::Transport_ptr);
void OBDuplicate(OCI::ConnectorInfo_ptr);
void OBRelease(OCI::ConnectorInfo_ptr);
void OBDuplicate(OCI::Connector_ptr);
void OBRelease(OCI::Connector_ptr);
void OBDuplicate(OCI::AcceptorInfo_ptr);
void OBRelease(OCI::AcceptorInfo_ptr);
void OBDuplicate(OCI::Acceptor_ptr);
void OBRelease(OCI::Acceptor_ptr);
void OBDuplicate(OCI::ConFactory_ptr);
void OBRelease(OCI::ConFactory_ptr);
void OBDuplicate(OCI::ConFactoryRegistry_ptr);
void OBRelease(OCI::ConFactoryRegistry_ptr);
void OBDuplicate(OCI::AccRegistry_ptr);
void OBRelease(OCI::AccRegistry_ptr);

namespace OCI
{

typedef OB::ObjVar< Buffer > Buffer_var;

typedef OB::ObjVar< TransportInfo > TransportInfo_var;

typedef OB::ObjVar< Transport > Transport_var;

typedef OB::ObjVar< ConnectorInfo > ConnectorInfo_var;

typedef OB::ObjVar< Connector > Connector_var;

typedef OB::ObjVar< AcceptorInfo > AcceptorInfo_var;

typedef OB::ObjVar< Acceptor > Acceptor_var;

typedef OB::ObjVar< ConFactory > ConFactory_var;

typedef OB::ObjVar< ConFactoryRegistry > ConFactoryRegistry_var;

typedef OB::ObjVar< AccRegistry > AccRegistry_var;

} // End namespace OCI

#endif
